Option Explicit
'
' ini Constants
'
Global Const SaverName = "Red Top"
Global Const iniName = "CONTROL.INI"
Global iniSection As String
Global Const Version = "Version 1.2"
'
' Common Globals for all Screen Savers
'
Global PWprotected As Integer
Global Password As Long
Global MouseMove As Integer
Global ValidPassword As Integer
Global OldPassword As Long
'
' Globals Specific to RedTop
'
Global SpinSpeed As Integer
'
' API Function Definitions
'
Declare Function ShowCursor Lib "User" (ByVal fShow As Integer) As Integer
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Integer
Declare Sub SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer)
Declare Function SetSysModalWindow Lib "User" (ByVal hWnd%) As Integer

'
' Simple Password Routine
'
' Input:  Password to be calculated
' Output: Long "Checksum" of Password
'
' NB. The password maintained in this screen saver is NOT the
'     Standard Windows Screen Saver Password. The password used
'     with this screen saver is maintained in
'     [Screen Saver.Red Top] Section in the Control.ini
'
Function CalcPassnum (Password As String) As Long

Dim i As Integer
Dim psum As Long

    psum = 0
    For i = 1 To Len(Password)
        psum = psum + ((Asc(Mid$(Password, i, 1)) ^ 2) * i)
    Next i
    
    CalcPassnum = psum

End Function

'
' Position the form in centre of the screen
'
Sub CentreForm (F As Form)

    F.Move (screen.Width / 2) - (F.Width / 2), (screen.Height / 2) - (F.Height / 2)

End Sub

'
' Wrapper for the API call GetPrivateProfileString
'
Function GetIni (IniFile As String, Appname As String, Keyword As String) As String

Dim ResultString As String * 128
Dim Temp As Integer
    
    Temp = GetPrivateProfileString(Appname, Keyword, "", ResultString, Len(ResultString), IniFile)
    GetIni = Left$(ResultString, Temp)

End Function

'
' Hide the mouse from the screen using API call ShowCursor
'
Sub HideMouse ()
    
    While ShowCursor(False) >= 0
    Wend

End Sub

'
' The Initialization of the Screen Saver.
' Branches to either the saver itself or the configuration form
' depending on the command line argument "/s or /c"
'
Sub main ()
    '
    ' end if the program is already running
    '
    If App.PrevInstance Then End
    '
    ' Set up the ini Section name
    '
    iniSection = "Screen Saver." & SaverName
    '
    ' Get all the Information from the Initialization file
    '
    PWprotected = Val(GetIni(iniName, iniSection, "PWprotected"))
    Password = CLng(Val(GetIni(iniName, iniSection, "Password")))
    OldPassword = Password
    If (GetIni(iniName, iniSection, "MouseMove")) = "1" Then
        MouseMove = True ' ie will not process MouseMove Event
    Else
        MouseMove = False ' ie will process MouseMove Event
    End If
    '
    ' The value specific to RedTop
    '
    SpinSpeed = Val(GetIni(iniName, iniSection, "SpinSpeed"))
    '
    ' branch to the appropriate form
    '
    If InStr(1, Command$, "/c", 1) Then ' upper or lower case
        frmSetup.Show
    ElseIf InStr(1, Command$, "/s", 1) Then ' upper or lower case
        ' Hide the mouse pointer
        Call HideMouse
        frmSaver.Show
    End If
    
End Sub

'
' Wrapper for the API call WritePrivateProfileString
'
Sub PutIni (IniFile As String, Appname As String, Keyword As String, KeyVal As String)

Dim Temp As Integer
    
    Temp = WritePrivateProfileString(Appname, Keyword, KeyVal, IniFile)

End Sub

'
' Show the mouse (previously hidden) using API call ShowCursor
'
Sub ShowMouse ()
    
    While ShowCursor(True) < 0
    Wend

End Sub

'
' Simple Password Routine
'
' Input:  Password to be checked, "Checksum" of Password
' Output: True or False
'
Function ValidatePassword (Password As String, passnum As Long) As Integer
    If CalcPassnum(Password) = passnum Then
        ValidatePassword = True
    Else
        ValidatePassword = False
    End If
End Function

